from appendonly import Accumulator

from karl.models.interfaces import ICatalogSearch
from karl.models.interfaces import IProfile


def evolve(site):
    """Add an Accumulator to remember old passwords.
    """
    search = ICatalogSearch(site)
    count, docids, resolver = search(
        interfaces={'query': [IProfile]},
    )
    for docid in docids:
        doc = resolver(docid)
        if hasattr(doc, 'password_history'):
            continue
        doc.password_history = Accumulator()
