from karl.models.interfaces import ICatalogSearch
from karl.models.interfaces import IProfile


def evolve(site):
    """Add a property to store the age of the current password.
    """
    search = ICatalogSearch(site)
    count, docids, resolver = search(
        interfaces={'query': [IProfile]},
    )
    for docid in docids:
        doc = resolver(docid)
        if hasattr(doc, 'password_changed_time'):
            continue
        doc.password_changed_time = None
