from karl.models.interfaces import ICatalogSearch
from karl.models.interfaces import IProfile


def evolve(site):
    """Add a property to store two-factor authentication secret.
    """
    search = ICatalogSearch(site)
    count, docids, resolver = search(
        interfaces={'query': [IProfile]},
    )
    for docid in docids:
        doc = resolver(docid)
        if hasattr(doc, 'two_factor_secret'):
            continue
        doc.two_factor_secret = None
